package com.ruoyi.dimp.service.impl;

import java.io.File;
import java.io.IOException;
import java.util.Date;
import java.util.List;
import java.util.Objects;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.ruoyi.common.config.RuoYiConfig;
import com.ruoyi.common.constant.Constants;
import com.ruoyi.common.utils.DateUtils;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.web.multipart.MultipartFile;

import com.ruoyi.common.utils.StringUtils;
import com.ruoyi.common.utils.file.FileUploadUtils;
import com.ruoyi.dimp.mapper.DHighValueInfoPreImpMapper;
import com.ruoyi.dimp.mapper.DPctApplyInfoPreImpMapper;
import com.ruoyi.dimp.domain.DHighValueInfoPreImp;
import com.ruoyi.dimp.domain.DPctApplyInfoPreImp;
import com.ruoyi.dimp.service.IDPctApplyInfoPreImpService;

/**
 * PCT申请导入记录Service业务层处理
 *
 * @author ruoyi
 * @date 2023-03-19
 */
@Service
public class DPctApplyInfoPreImpServiceImpl extends ServiceImpl<DPctApplyInfoPreImpMapper, DPctApplyInfoPreImp> implements IDPctApplyInfoPreImpService {

	private static final Logger logger = LoggerFactory.getLogger(DPctApplyInfoPreImpServiceImpl.class);

	@Autowired
	private RuoYiConfig ruoYiConfig;
	
	@Autowired
	private DPctApplyInfoPreImpMapper dPctApplyInfoPreImpMapper;
	
	public String getImpPath() {
		return ruoYiConfig.getProfile() + "/DPctApplyInfoPreImp";
	}

	
	public DPctApplyInfoPreImp importData(MultipartFile file) {
		DPctApplyInfoPreImp imp = new DPctApplyInfoPreImp();
		try {
			String impres = FileUploadUtils.upload(getImpPath(), file);

			impres = impres.substring(Constants.RESOURCE_PREFIX.length());
			impres = RuoYiConfig.getProfile() + impres;

			imp.setFilePath(impres);
			
			String filePath = impres;
			File path = new File(filePath).getParentFile();
			
			String fileName = new File(impres).getName();
			
			String resFileName = fileName.substring(0, fileName.lastIndexOf(".")) + ""
					+ fileName.substring(fileName.lastIndexOf("."), fileName.length());
			
			int dirLastIndex = RuoYiConfig.getProfile().length() + 1;
			String currentDir = StringUtils.substring(path.getAbsolutePath(), dirLastIndex);
			String res = Constants.RESOURCE_PREFIX + "/" + currentDir + "/" + resFileName;

			imp.setFileUrl(ruoYiConfig.getFilePath() + res);
			
			imp.setPreImpTime(new Date());
			imp.setFileName(fileName);
			imp.setImpState("0");//
			imp.setDataSrc("Web导入");
			imp.setInsertNum(0L);
			imp.setSkipNum(0L);
			imp.setUpdateNum(0L);
			imp.setErrorNum(0L);
			imp.setErrReason("系统已接收");
			dPctApplyInfoPreImpMapper.insert(imp);

		} catch (IOException e) {
			logger.error("PCT申请导入失败," + e.getMessage(), e);
			String res = "导入失败，原因:" + e.getMessage();
			imp.setErrReason(res);
		}

		return imp;
	}
	
    /**
     * 查询PCT申请导入记录列表
     *
     * @param dPctApplyInfoPreImp PCT申请导入记录
     * @return PCT申请导入记录集合
     * @date 2023-03-19
     */
    @Override
    public List<DPctApplyInfoPreImp> queryList(DPctApplyInfoPreImp dPctApplyInfoPreImp) {
        QueryWrapper<DPctApplyInfoPreImp> queryWrapper = Wrappers.query();
                if (  StringUtils.isNotNull(dPctApplyInfoPreImp.getPreImpTime())){
                    queryWrapper.eq("pre_imp_time", dPctApplyInfoPreImp.getPreImpTime());
                }
                if ( StringUtils.isNotEmpty(dPctApplyInfoPreImp.getFileName())  ){
                    queryWrapper.like("file_name", dPctApplyInfoPreImp.getFileName());
                }
                if ( StringUtils.isNotEmpty(dPctApplyInfoPreImp.getFileUrl())  ){
                    queryWrapper.eq("file_url", dPctApplyInfoPreImp.getFileUrl());
                }
                if ( StringUtils.isNotEmpty(dPctApplyInfoPreImp.getImpState())  ){
                    queryWrapper.eq("imp_state", dPctApplyInfoPreImp.getImpState());
                }
                if ( StringUtils.isNotEmpty(dPctApplyInfoPreImp.getTenantNo())  ){
                    queryWrapper.eq("tenant_no", dPctApplyInfoPreImp.getTenantNo());
                }
                if (  StringUtils.isNotNull(dPctApplyInfoPreImp.getInsertNum())){
                    queryWrapper.eq("insert_num", dPctApplyInfoPreImp.getInsertNum());
                }
                if (  StringUtils.isNotNull(dPctApplyInfoPreImp.getUpdateNum())){
                    queryWrapper.eq("update_num", dPctApplyInfoPreImp.getUpdateNum());
                }
                if (  StringUtils.isNotNull(dPctApplyInfoPreImp.getSkipNum())){
                    queryWrapper.eq("skip_num", dPctApplyInfoPreImp.getSkipNum());
                }
                if (  StringUtils.isNotNull(dPctApplyInfoPreImp.getErrorNum())){
                    queryWrapper.eq("error_num", dPctApplyInfoPreImp.getErrorNum());
                }
                if ( StringUtils.isNotEmpty(dPctApplyInfoPreImp.getDataSrc())  ){
                    queryWrapper.eq("data_src", dPctApplyInfoPreImp.getDataSrc());
                }
                if ( StringUtils.isNotEmpty(dPctApplyInfoPreImp.getErrReason())  ){
                    queryWrapper.eq("err_reason", dPctApplyInfoPreImp.getErrReason());
                }
                if ( StringUtils.isNotEmpty(dPctApplyInfoPreImp.getResFileName())  ){
                    queryWrapper.like("res_file_name", dPctApplyInfoPreImp.getResFileName());
                }
                if ( StringUtils.isNotEmpty(dPctApplyInfoPreImp.getResFileUrl())  ){
                    queryWrapper.eq("res_file_url", dPctApplyInfoPreImp.getResFileUrl());
                }
        queryWrapper.orderByDesc("id");
        return this.list(queryWrapper);
    }
}
